#!/bin/bash

{{ ansible_managed | comment }}

# Only start backup if lock from consul is acquired

set -u

exec 1> >(ts >> {{ walg_log_directory }}/wal-g_backup_push.log) 2>&1
exec 2> >(ts >> {{ walg_log_directory }}/wal-g_backup_push.log)

JOBNAME="walg-basebackup"

LOCKNAME="${JOBNAME}-{{ shard }}"

## GitLab Job metric settings
# https://gitlab.com/gitlab-com/runbooks/-/blob/master/docs/uncategorized/job_completion.md
RESOURCE="$JOBNAME"
MAX_AGE='108000' # 30 Hours.
PROM_SHARD='shard/{{ shard }}'
PROM_TIER='tier/db'
PROM_TYPE='type/{{ type }}'

PUSH_URL="http://localhost:9091/metrics/job/$JOBNAME/${PROM_SHARD}/${PROM_TIER}/${PROM_TYPE}"
PUSH_CMD="curl -siv --data-binary @- ${PUSH_URL}"

key="pgbackup_{{ gitlab_rb_patroni['scope'] }}_$(date +'%Y%m%d')"

pushgateway(){
  ${PUSH_CMD}
}

push_start_txt(){
  cat <<PROM
# HELP gitlab_job_start_timestamp_seconds The start time of the job.
# TYPE gitlab_job_start_timestamp_seconds gauge
gitlab_job_start_timestamp_seconds{resource="${RESOURCE}"} $(date +%s)
# HELP gitlab_job_max_age_seconds How long the job is allowed to run before marking it failed.
# TYPE gitlab_job_max_age_seconds gauge
gitlab_job_max_age_seconds{resource="${RESOURCE}"} ${MAX_AGE}
# HELP gitlab_job_failed Boolean status of the job.
# TYPE gitlab_job_failed gauge
gitlab_job_failed{resource="${RESOURCE}"} 0
PROM
}

push_finish() {
  cat <<PROM | pushgateway
# HELP gitlab_job_success_timestamp_seconds The time the job succeeded.
# TYPE gitlab_job_success_timestamp_seconds gauge
gitlab_job_success_timestamp_seconds{resource="${RESOURCE}"} $(date +%s)
PROM
}


error_out(){
  local msg="$1"
  echo "$msg" 2>&1

  cat <<PROM | pushgateway
# HELP gitlab_job_failed Boolean status of the job.
# TYPE gitlab_job_failed gauge
gitlab_job_failed{resource="${RESOURCE}"} 1
PROM
}

patroni_role() {
  if gitlab-ctl patroni members | grep $(hostname) | grep -q Leader; then
    echo Leader
  else
    echo Replica
  fi
}

backup() {
  echo "start backup $key ..."

  # we are holding the lock in consul for as long as the backup is running, if we can acquire it
  export DATADIR="$(gitlab-psql -tAc 'SHOW data_directory')"
  SHELL="/bin/bash" PGPORT="$(gitlab-psql -tAc 'SHOW port')" PGHOST="localhost" PGUSER="{{ walg_user }}" PGDATABASE="postgres"\
    /opt/gitlab/embedded/bin/consul lock -timeout 1s -child-exit-code "$LOCKNAME" "echo '$(push_start_txt)' | ${PUSH_CMD}; /usr/bin/envdir {{ walg_envvar_directory }} {{ walg_executable_path }} backup-push ${DATADIR}"

  ret="$?"

  if [ "$ret" == 1 ]; then
    echo "Could not acquire $LOCKNAME lock. Will not run backup."
    return 0
  elif [ "$ret" == 2 ]; then
    error_out "Backup command returned non-zero exit code."
    return 2
  elif [ "$ret" == 0 ]; then
    echo "end backup $key."
    push_finish
    return 0
  else
    error_out "Unknown backup error"
    return $ret
  fi
}

role=$(patroni_role)

if [ "$role" == "Leader" ]; then
  echo "I'm the primary. Will not run backup."
  exit
fi

backup
